



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Mybatis入门和简单Demo</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Mybatis入门和简单Demo</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 19:18:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一、Mybatis的诞生</strong></p>
<p><strong>　　</strong>回顾下传统的数据库开发，JDBC和Hibernate是使用最普遍的技术，但这两种ORM框架都存在一定的局限性：</p>
<p>　　JDBC：最原生的技术，简单易学，执行速度快，效率高，适合大数据量的操作，但存在代码繁琐，需要关心驱动的加载，连接的关闭等操作，对于分页等复杂用法，需要自己手动写代码实现。</p>
<p>　　Hibernate：以面向对象的方式设计和访问，不用写SQL，不用管底层具体数据库的语法，但对于多表操作灵活性差，复杂的HQL难写难理解，执行速度慢，只适合小数据量的操作。</p>
<p>　　基于上述技术的瓶颈，诞生了一种在这两者之间找到平衡点的ORM框架，结合它们的优点，摒弃它们的缺点，这就是myBatis，现今myBatis被广泛的企业所采用。MyBatis 本是apache的一个开源项目iBatis, 2010年这个项目由apache software foundation 迁移到了google code，并且改名为MyBatis 。2013年11月迁移到Github。iBATIS一词来源于&ldquo;internet&rdquo;和&ldquo;abatis&rdquo;的组合，是一个基于Java的持久层框架。iBATIS提供的持久层框架包括SQL Maps和Data Access Objects（DAO）</p>
<p><strong>二、Mybatis入门Demo（基于MySQL）</strong></p>
<p>　　Mybatis程序的运行流程大概如下：</p>
<p>　　（1）通过Reader对象读取src目录下的mybatis.xml配置文件（该文件名称可自定义，主要用来配置数据源，类型别名以及mapper文件的总配置文件）</p>
<p>　　（2）通过SqlSessionFactoryBuilder对象创建SqlSessionFactory对象</p>
<p>　　（3）从当前线程，即ThreadLocal中获取SqlSession对象<br />　　（4）开启事务（默认开启）<br />　　（5）通过SqlSession对象读取对应Mapper.xml映射文件中的操作编号，从而读取sql语句<br />　　（6）提交或回滚事务<br />　　（7）关闭SqlSession对象，并且分开当前线程与SqlSession对象，让GC尽早回收</p>
<p>　　基于上述步骤开始Mybatis入门Demo案例的编写：</p>
<p>　　步骤1.引入Mybatis所需jar包依赖</p>
<div>
<pre class="prettyprint linenums">       &lt;dependency&gt;<br />
            &lt;groupId&gt;org.mybatis&lt;/groupId&gt;<br />
            &lt;artifactId&gt;mybatis&lt;/artifactId&gt;<br />
            &lt;version&gt;3.3.0&lt;/version&gt;<br />
        &lt;/dependency&gt;

        &lt;dependency&gt;<br />
            &lt;groupId&gt;mysql&lt;/groupId&gt;<br />
            &lt;artifactId&gt;mysql-connector-java&lt;/artifactId&gt;<br />
            &lt;version&gt;5.1.38&lt;/version&gt;<br />
        &lt;/dependency&gt;

        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.slf4j&lt;/groupId&gt;<br />
            &lt;artifactId&gt;slf4j-api&lt;/artifactId&gt;<br />
            &lt;version&gt;1.7.12&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.slf4j&lt;/groupId&gt;<br />
            &lt;artifactId&gt;slf4j-log4j12&lt;/artifactId&gt;<br />
            &lt;version&gt;1.7.12&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;log4j&lt;/groupId&gt;<br />
            &lt;artifactId&gt;log4j&lt;/artifactId&gt;<br />
            &lt;version&gt;1.2.17&lt;/version&gt;<br />
        &lt;/dependency&gt; </pre>
</div>
<p>　　步骤2.准备数据源db.properties并配置mybatis.xml文件</p>
<div>
<pre class="prettyprint linenums">mysql.driver=com.mysql.jdbc.Driver<br />
mysql.url=jdbc:mysql://localhost:3306/aa<br />
mysql.username=root<br />
mysql.password=123456</pre>
</div>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
&lt;!DOCTYPE configuration PUBLIC "-//mybatis.org//DTD Config 3.0//EN"<br />
"http://mybatis.org/dtd/mybatis-3-config.dtd"&gt;

&lt;configuration&gt;

    &lt;!-- 加载类路径下的属性文件 --&gt;<br />
    &lt;properties resource="db.properties"&gt;<br />
    &lt;/properties&gt;

    &lt;!-- 设置实体类的类型别名 --&gt;<br />
    &lt;typeAliases&gt;<br />
        &lt;typeAlias type="com.jyk.mybatis.Student" alias="student"/&gt;<br />
    &lt;/typeAliases&gt;

    &lt;!-- 设置一个默认的连接环境信息，支持多数据源 --&gt;<br />
    &lt;environments default="mysql_env"&gt;<br />
        &lt;!-- 连接环境信息，取一个唯一的编号 --&gt;<br />
        &lt;environment id="mysql_env"&gt;<br />
            &lt;!-- mybatis使用的jdbc事务管理方式 --&gt;<br />
            &lt;transactionManager type="jdbc"&gt;<br />
            &lt;/transactionManager&gt;

            &lt;!-- mybatis使用连接池方式来获取链接 --&gt;<br />
            &lt;dataSource type="pooled"&gt;<br />
                &lt;!-- 配置与数据库交互的四个属性 --&gt;<br />
                &lt;property name="driver" value="${mysql.driver}"/&gt;<br />
                &lt;property name="url" value="${mysql.url}"/&gt;<br />
                &lt;property name="username" value="${mysql.username}"/&gt;<br />
                &lt;property name="password" value="${mysql.password}"/&gt;<br />
            &lt;/dataSource&gt;<br />
        &lt;/environment&gt;<br />
    &lt;/environments&gt;<br />
    <br />
    &lt;mappers&gt;<br />
        &lt;mapper resource="com/jyk/mybatis/StudentMapper.xml"/&gt;<br />
    &lt;/mappers&gt;

&lt;/configuration&gt;</pre>
</div>
<p>　　步骤3.编写需要操作的实体类com.jyk.mybatis.Student记录学生信息</p>
<div>
<pre class="prettyprint linenums">package com.jyk.mybatis;

public class Student {

    private String id;<br />
    private String name;<br />
    private String age;<br />
    private String sex;

    public String getId() {<br />
        return id;<br />
    }<br />
    public void setId(String id) {<br />
        this.id = id;<br />
    }<br />
    public String getName() {<br />
        return name;<br />
    }<br />
    public void setName(String name) {<br />
        this.name = name;<br />
    }<br />
    public String getAge() {<br />
        return age;<br />
    }<br />
    public void setAge(String age) {<br />
        this.age = age;<br />
    }<br />
    public String getSex() {<br />
        return sex;<br />
    }<br />
    public void setSex(String sex) {<br />
        this.sex = sex;<br />
    }

    public Student(String id, String name, String age, String sex) {<br />
        super();<br />
        this.id = id;<br />
        this.name = name;<br />
        this.age = age;<br />
        this.sex = sex;<br />
    }

    public Student() {<br />
        super();<br />
    }<br />
}</pre>
</div>
<p>　　步骤4.配置StudentMapper.xml，配置namespace，需要唯一，一般以需要操作的实体类全路径为准，也可为其他值。然后是配置实体类与实际表的映射关系resultMap，type属性:实体全路径名，可在mybatis.xml文件中统一配置，如在上述mybatis.xml中已配置&lt;typeAlias type="com.jyk.mybatis.Student" alias="student"/&gt;，则此处实体类全路径可用student代替</p>
<p>　　注：当实体属性名与表字段名不一样时，此处信息必配，若一致，则此处配置可选。</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8" ?&gt;<br />
&lt;!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"<br />
"http://mybatis.org/dtd/mybatis-3-mapper.dtd"&gt;

&lt;!-- 名称空间namespace必须唯一 --&gt;<br />
&lt;mapper namespace="studentNamespace"&gt;

    &lt;!--<br />
        resultMap标签：映射实体与表，非主键属性标签<br />
        type属性:实体全路径名，可在mybatis.xml文件中统一配置<br />
        id属性:为实体与表的映射取一个唯一的编号<br />
     --&gt;<br />
    &lt;resultMap type="student" id="studentMap"&gt;<br />
        &lt;!--<br />
        id标签:映射主键属性<br />
        result标签：映射非主键属性<br />
        property属性:实体属性名<br />
        column属性：表的字段名<br />
         --&gt;<br />
        &lt;id property="id" column="id"/&gt;<br />
        &lt;result property="name" column="name"/&gt;<br />
        &lt;result property="age" column="age"/&gt;<br />
        &lt;result property="sex" column="sex"/&gt;<br />
    &lt;/resultMap&gt;

&lt;/mapper&gt;</pre>
</div>
<p>　　步骤5.编写Mybatis通用工具类，通过Reader对象读取src目录下的mybatis.xml配置文件，并测试连接</p>
<div>
<pre class="prettyprint linenums">package com.jyk.mybatis.util;

import java.io.IOException;<br />
import java.io.Reader;<br />
import java.sql.Connection;

import org.apache.ibatis.io.Resources;<br />
import org.apache.ibatis.session.SqlSession;<br />
import org.apache.ibatis.session.SqlSessionFactory;<br />
import org.apache.ibatis.session.SqlSessionFactoryBuilder;

/*<br />
 * MyBatis工具类<br />
 */<br />
public class MyBatisUtil {

    private static ThreadLocal&lt;SqlSession&gt; threadLocal = new<br />
            ThreadLocal&lt;SqlSession&gt;();<br />
    private static SqlSessionFactory sqlSessionFactory;

    //静态块加载src目录下的mybatis配置文件<br />
    static{<br />
        try {<br />
            Reader reader = Resources.getResourceAsReader("mybatis.xml");<br />
            sqlSessionFactory = new SqlSessionFactoryBuilder().build(reader);<br />
        } catch (IOException e) {<br />
            e.printStackTrace();<br />
        }<br />
    }

    /*<br />
     * 禁止外界通过new方法创建<br />
     */<br />
    private MyBatisUtil(){}

    /*<br />
     * 获取sqlsession<br />
     */<br />
    public static SqlSession getSqlSession()<br />
    {<br />
        //从当前线程中获取sqlSession对象<br />
        SqlSession sqlSession = threadLocal.get();

        //判断SqlSession对象是否为空<br />
        if(sqlSession==null)<br />
        {<br />
            //在SqlSessionFactory对象非空的情况下，获取SqlSession对象<br />
            sqlSession = sqlSessionFactory.openSession();<br />
            //将SqlSession对象与当前线程绑定在一起<br />
            threadLocal.set(sqlSession);<br />
        }

        return sqlSession;<br />
    }

    /*<br />
     * 关闭sqlsession与当前线程分开<br />
     */<br />
    public static void closeSqlSession()<br />
    {<br />
        //从当前线程中获取SqlSession对象<br />
        SqlSession sqlSession = threadLocal.get();

        if(sqlSession != null)<br />
        {<br />
            //关闭SqlSession对象<br />
            sqlSession.close();<br />
            //分开当前线程与SqlSession对象的关系，目的是尽早进行垃圾回收<br />
            threadLocal.remove();<br />
        }<br />
    }

    /*<br />
     * 测试方法<br />
     */<br />
    public static void main(String[] args) {<br />
        Connection conn = MyBatisUtil.getSqlSession().getConnection();<br />
        if(conn==null)<br />
        {<br />
            System.out.println("连接为空");<br />
        }<br />
        else<br />
        {<br />
            System.out.println("连接不为空");<br />
        }<br />
    }<br />
}</pre>
</div>
<p>　　步骤6.编写CRUD语句，在mapper文件中编写，此处编写在上述已经配置好实体类映射的StudentMapper.xml文件中</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8" ?&gt;<br />
&lt;!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"<br />
"http://mybatis.org/dtd/mybatis-3-mapper.dtd"&gt;

&lt;!-- 名称空间namespace必须唯一 --&gt;<br />
&lt;mapper namespace="studentNamespace"&gt;

    &lt;!--<br />
        resultMap标签：映射实体与表<br />
        type属性:实体全路径名<br />
        id属性:为实体与表的映射取一个唯一的编号<br />
     --&gt;<br />
    &lt;resultMap type="student" id="studentMap"&gt;<br />
        &lt;!--<br />
        id标签:映射主键属性<br />
        result标签：映射非主键属性<br />
        property属性:实体属性名<br />
        column属性：表的字段名<br />
         --&gt;<br />
        &lt;id property="id" column="id"/&gt;<br />
        &lt;result property="name" column="name"/&gt;<br />
        &lt;result property="age" column="age"/&gt;<br />
        &lt;result property="sex" column="sex"/&gt;<br />
    &lt;/resultMap&gt;

    &lt;!--<br />
    insert标签:sql插入语句<br />
    id属性：该sql语句的唯一标签<br />
    parameterType:要执行的dao中的方法的参数，如果是类的话，必须使用全路径名<br />
    #{xx}：mybatis特有语法，用来替代jdbc中的?占位符<br />
     --&gt;<br />
    &lt;insert id="add1"&gt;<br />
    insert into student(id,name,age,sex) values("1","admin","22","男")<br />
    &lt;/insert&gt;

    &lt;insert id="add2" parameterType="student"&gt;<br />
    insert into student(id,name,age,sex) values(#{id},#{name},#{age},#{sex})<br />
    &lt;/insert&gt;

    &lt;!-- &lt;insert id="add3" parameterType="student"&gt;<br />
    insert into student(id,name,age,sex) values(#{id},#{name},#{age},#{sex})<br />
    &lt;/insert&gt; --&gt;<br />
&lt;/mapper&gt;</pre>
</div>
<p>　　步骤7.编写DAO，利用上述配置完成的文件和写好的通用工具类MyBatisUtil对学生信息进行增删该查</p>
<div>
<pre class="prettyprint linenums">package com.jyk.mybatis;

import org.apache.ibatis.session.SqlSession;

import com.jyk.mybatis.util.MyBatisUtil;

public class StudentDao {

    /*<br />
     * 增加的方法1<br />
     */<br />
    public void add1()<br />
    {<br />
        SqlSession sqlSession = null;<br />
        try{<br />
            sqlSession = MyBatisUtil.getSqlSession();<br />
            //事务开始（默认）

            //读取StudentMapper.xml配置文件中的sql语句，对应的sql语句由{名称空间.sql的id指定}<br />
            int i = sqlSession.insert("studentNamespace.add1");<br />
            System.out.println("本次操作影响了"+i+"行数据");

            //事务提交<br />
            sqlSession.commit();<br />
        }catch(Exception e){<br />
            e.printStackTrace();<br />
            //事务回滚<br />
            sqlSession.rollback();<br />
            throw e;<br />
        }finally{<br />
            MyBatisUtil.closeSqlSession();<br />
        }<br />
    }

    /*<br />
     * 增加的方法2<br />
     */<br />
    public void add2(Student stu)<br />
    {<br />
        SqlSession sqlSession = null;<br />
        try{<br />
            sqlSession = MyBatisUtil.getSqlSession();<br />
            //事务开始（默认）

            //读取StudentMapper.xml配置文件中的sql语句<br />
            int i = sqlSession.insert("studentNamespace.add2",stu);<br />
            System.out.println("本次操作影响了"+i+"行数据");

            //事务提交<br />
            sqlSession.commit();<br />
        }catch(Exception e){<br />
            e.printStackTrace();<br />
            //事务回滚<br />
            sqlSession.rollback();<br />
            throw e;<br />
        }finally{<br />
            MyBatisUtil.closeSqlSession();<br />
        }<br />
    }

    /*<br />
     * 增加的方法3<br />
     * 往数据库添加记录必须要添加事务，没有事务添加不进去<br />
     */<br />
    public void add3(Student stu)<br />
    {<br />
        SqlSession sqlSession = null;<br />
        try{<br />
            sqlSession = MyBatisUtil.getSqlSession();<br />
            //事务开始（默认）

            //读取StudentMapper.xml配置文件中的sql语句<br />
            int i = sqlSession.insert("studentNamespace.add3",stu);<br />
            System.out.println("本次操作影响了"+i+"行数据");<br />
            sqlSession.commit();<br />
        }catch(Exception e){<br />
            e.printStackTrace();<br />
            //事务回滚<br />
            sqlSession.rollback();<br />
            throw e;<br />
        }finally{<br />
            MyBatisUtil.closeSqlSession();<br />
        }<br />
    }

    public static void main(String[] args) {<br />
        StudentDao sd = new StudentDao();<br />
        sd.add1();<br />
        sd.add2(new Student("64","kaiye","23","男"));<br />
    }<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qygeyjq.html">开源安卓Http文件下载框架file-downloader的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq47meeq.html">Cauchy 级数浓缩判别法</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jg2rg9.html">【转】在mac上配置安卓SDK</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4o6yj8.html">color 和 mode</a>
		</li>
						<li><a href="https://www.batexi.com/a/39ro2gr9.html">Android SQLite数据库版本升级原理解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1r3yv9.html">SVN的搭建和使用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j07g4gq.html">shell入门之流程控制语句                                                    分类：            学习笔记             linux             ubuntu             2015-07-10 16&colon;38    89人阅读    评论&lpar;0&rpar;    收藏</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdm12y8.html">SpringMVC简单搭建与入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vgl5j8.html">【Linux常用命令（更新）】</a>
		</li>
						<li><a href="https://www.batexi.com/a/950zgre8.html">迈向angularjs2系列&lpar;7&rpar;&colon;表单</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rjdg58.html">C&plus;&plus; Primer 笔记&mdash;&mdash;重载运算</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvnw138.html">数据库行转列、列转行，pivot透视多列</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwgv109.html">C&plus;&plus; 是 编程界 的 背锅侠</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjxwel9.html">while else 结构体&lpar;自测&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25ng33q.html">JavaScript之Dom操作【删除当前节点】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5p3ldq.html">springboot集成swagger2，构建优雅的Restful API</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvg5dz8.html">&lbrack;原&rsqb;&lbrack;osg&rsqb;osgconv浅析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r3n258.html">Spark各个版本新特性</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4g13eq.html">sqoop导入导出对mysql再带数据库test能跑通用户自己建立的数据库则不行</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvge0mq.html">关于EJB，为什么用EJB？为什么不用EJB？</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyvnl3jq.html">js正则表达式的基本语法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnn66ljq.html">ubuntu wine-qq安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko6zmjq.html">mybatis由浅入深day02&lowbar;8spring和mybatis整合</a>
			</li>
						<li><a href="https://www.batexi.com/a/953lkxm8.html">Python 字符串处理（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnp21mq.html">VR室内定位系统小结</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1drdk9.html">ARM承认芯片漏洞：披露修复细节</a>
			</li>
						<li><a href="https://www.batexi.com/a/9632rej9.html">关于微信的jsdk的若干亲身实践之小结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlp2lk9.html">bootstrap里面的popover组件如何使鼠标移入可以对弹出框进行一系列的操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnpx07q.html">iOS - UIImageView - how to handle UIImage image orientation</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vo3w6q.html">PyQt4 菜单栏 &plus; 工具栏 &plus; 状态栏 &plus; 中心部件 生成一个文本编辑部件示例</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
